/*
 * mainloop.cpp
 *
 *  Created on: 22.11.2017
 *      Author: ubuntu
 */

#include "mainloop.hpp"


using namespace std;
using namespace cv;

void main_loop::loop(cv::Mat3b* src,
					 array<uint16_t, 10>* x_out,
					 array<int16_t, 10>* y_out,
					 array<int16_t, 10>* theta_out,
					 array<int16_t, 10>* kappa_out) {
	
	// prepare the output window
	if(screen_exists){
		coord.get_Coordinate_System(&coordinates);
		printf("coord");
	}
	
	
	// prepare the frame calculation
//	frame.frame_beginning();
//	printf("fame_beginning");
	
	// copy the src to a different Mat for later output use
	if(screen_exists){
		src->copyTo(src_processed);
		printf("copy source");
	}

	// detect the edges
	edge.detect(src, &grad_x, &grad_y);
	printf("edges \n");
	
	// filter for vectors on the inside
	c.concatenate(&grad_x, &grad_y, &contour_l, &contour_r);
	printf("concat\n");	

	// output
	if(screen_exists){
		draw_points(&src_processed,
			    &contour_l, color_l,
			    &contour_r, color_r);
		imshow("output", src_processed);
	}


	// transform the points into more precise points
	to_pPoints(&contour_l, &pcontours_l,
			   &contour_r, &pcontours_r);
	printf("to ppoints\n");
			   

	// transform them into si-unit points
	coordinate.transform(&pcontours_l, &real_l,
						 &pcontours_r, &real_r,
						 true);
	printf("transform\n");

	//output
	if(screen_exists){
		coord.draw_points(&coordinates, &real_l, color_l);
		coord.draw_points(&coordinates, &real_r, color_r);
		imshow("coord", coordinates);
	}


	// fit all the points to a vector function
	Lane::fit_lane_pair(&real_l, &vec_l, 
			    &real_r, &vec_r, 
			    pow_poly);	
	printf("fit lane\n");
// ##### the following code is just for debugging and showing the vector functions #####
// ############### and is therefore not needed and can be commented out ################
	if(screen_exists){
		// ouput in coordinate system (optional)
		coord.plot_vec_func(&coordinates, &vec_l, color_l);
		coord.plot_vec_func(&coordinates, &vec_r, color_r);
		imshow("coord", coordinates);

		// calculate sample points that we can project into
		// the original image to see the fit
		// (needed for the rest of the vector function output,
		//  but not for the rest of the code)
		Function::get_point_representation(&vec_l, &fitted_l, 200);
		Function::get_point_representation(&vec_r, &fitted_r, 200);

		// ouput for the sample points in the coordinate system
		coord.draw_points(&coordinates, &fitted_l, color_l);
		coord.draw_points(&coordinates, &fitted_r, color_r);
		imshow("coord", coordinates);


		// transform the sampple points back to the image coordinates
		coordinate.transform(&fitted_l, &pcontours_l,
							 &fitted_r, &pcontours_r,
							 false);

		to_Points(&pcontours_l, &contour_l, &pcontours_r, &contour_r);

		// draw them onto the original image
		draw_points(src, &contour_l, color_l, &contour_r, color_r);
		imshow("output2", *src);
	}

// ############ from here on the code is necessary for the proper function ##############


//--TODO Mittellinie berechnen -----------------------------------------------------


	Function::calc_middle_vec_func(&vec_l, &vec_r, &vec_m);
	printf("middle\n");

	if(Function::is_usable(&vec_m)){

		Lane::remove_artifact(&vec_m, 20);

		if(screen_exists){
			cout << "____________" << endl;
			cout << "start_t: " << vec_m.start_t << endl;
			cout << "end_t : " << vec_m.end_t << endl;
			print_vector(vec_m.poly_x, "poly_x");
			print_vector(vec_m.poly_y, "poly_y");

			Function::get_point_representation(&vec_m, &fitted_m, 200);
			coord.draw_points(&coordinates, &fitted_m, color_m);
			imshow("coord", coordinates);

			coordinate.transf(&fitted_m, &pcontours_m, false);
			to_Points(&pcontours_m, &contour_m);
			draw_points(src, &contour_m, color_m);
			imshow("output2", *src);
		}
	}

	// FSE-Punkte der Mittellinie berechnen

	printf("pre	ego_lane\n");
	
	ego_lane.reset();

	ego_lane.calc_lane(&vec_m); // <- TODO (hier geht das Problem los)

	ego_lane.get_lane_as_arrays(x_out, y_out, theta_out, kappa_out);

	// hier gibt es derzeit einen komischen Fehler in der Ausgabe. scheint eine art
	// wraparround aufgrund des uints zu sein ( da nur in y )
	for(auto& s: *x_out)
	        cout << s << ' ';
	cout << endl;
	for(auto& s: *y_out)
			cout << s << ' ';
	cout << endl;
	cout << endl;
	
	printf("post ego_lane\n");
	
	// optical representation
	if(screen_exists){
		ego_lane.get_lane_as_points(&lane_pPoints);
		coordinate.transf(&lane_pPoints, &lane_pPoints_t, false);
		to_Points(&lane_pPoints_t, &lane_Points);
		draw_points(src, &lane_Points, Scalar(0, 0, 255));
		imshow("output2", *src);
		waitKey(1);
	}

//	frame.calculate_fps();

}
